<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celtool/persisthelper.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">celtool/persisthelper.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2005 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,</span>
<a name="l00018"></a>00018 <span class="comment">    MA 02111-1307, USA.</span>
<a name="l00019"></a>00019 <span class="comment">*/</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __CEL_CELTOOL_PERSISTHELPER__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_CELTOOL_PERSISTHELPER__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/util_8h.html">csutil/util.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2array_8h.html">csutil/array.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/set_8h.html">csutil/set.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;celtool/celtoolextern.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;physicallayer/persist.h&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;physicallayer/propclas.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">struct </span><a class="code" href="structiCelPlLayer.html" title="This is the Physical Layer itself.">iCelPlLayer</a>;
<a name="l00036"></a>00036 
<a name="l00043"></a><a class="code" href="classcelStandardLocalEntitySet.html">00043</a> <span class="keyword">class </span>CEL_CELTOOL_EXPORT <a class="code" href="classcelStandardLocalEntitySet.html" title="Standard implementation of iCelLocalEntitySet.">celStandardLocalEntitySet</a> : 
<a name="l00044"></a>00044   <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfImplementation1.html">scfImplementation1</a>&lt;celStandardLocalEntitySet, 
<a name="l00045"></a>00045                              iCelLocalEntitySet&gt;
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">private</span>:
<a name="l00048"></a>00048   <a class="code" href="structiCelPlLayer.html" title="This is the Physical Layer itself.">iCelPlLayer</a>* pl;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;iCelEntity*&gt;</a> local_entities;
<a name="l00051"></a>00051   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsSet.html">csSet&lt;csPtrKey&lt;iCelEntity&gt;</a> &gt; local_entities_set;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054   <a class="code" href="classcelStandardLocalEntitySet.html" title="Standard implementation of iCelLocalEntitySet.">celStandardLocalEntitySet</a> (<a class="code" href="structiCelPlLayer.html" title="This is the Physical Layer itself.">iCelPlLayer</a>* pl);
<a name="l00055"></a>00055   <span class="keyword">virtual</span> ~<a class="code" href="classcelStandardLocalEntitySet.html" title="Standard implementation of iCelLocalEntitySet.">celStandardLocalEntitySet</a> ();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetEntityCount ()<span class="keyword"> const</span>
<a name="l00058"></a>00058 <span class="keyword">  </span>{
<a name="l00059"></a>00059     <span class="keywordflow">return</span> local_entities.GetSize ();
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* GetEntity (<span class="keywordtype">size_t</span> idx)<span class="keyword"> const</span>
<a name="l00062"></a>00062 <span class="keyword">  </span>{
<a name="l00063"></a>00063     <span class="keywordflow">return</span> local_entities[idx];
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <span class="keywordtype">void</span> AddEntity (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity)
<a name="l00066"></a>00066   {
<a name="l00067"></a>00067     local_entities.Push (entity);
<a name="l00068"></a>00068     local_entities_set.Add (entity);
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> IsLocal (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity)
<a name="l00071"></a>00071   {
<a name="l00072"></a>00072     <span class="keywordflow">return</span> local_entities_set.In (entity);
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> IsLocal (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc)
<a name="l00075"></a>00075   {
<a name="l00076"></a>00076     <span class="keywordflow">return</span> local_entities_set.In (pc-&gt;<a class="code" href="structiCelPropertyClass.html#aedd94ad88ef06ce28c8265dbf786c29a" title="Get the parent entity associated with this property class.">GetEntity</a> ());
<a name="l00077"></a>00077   }
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> SaveExternalEntity (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity);
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* FindExternalEntity (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf);
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> SaveExternalPC (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc);
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* FindExternalPC (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf);
<a name="l00082"></a>00082 };
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classcelStandardPersistentDataList.html">00087</a> <span class="keyword">class </span>CEL_CELTOOL_EXPORT <a class="code" href="classcelStandardPersistentDataList.html" title="Standard implementation of iCelPersistentDataList.">celStandardPersistentDataList</a> : 
<a name="l00088"></a>00088   <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfImplementation1.html">scfImplementation1</a>&lt;celStandardPersistentDataList, 
<a name="l00089"></a>00089                              iCelPersistentDataList&gt;
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091  <span class="keyword">private</span>:
<a name="l00092"></a>00092   <span class="keyword">class </span>celPersistentDataEntry
<a name="l00093"></a>00093   {
<a name="l00094"></a>00094   <span class="keyword">public</span>:
<a name="l00095"></a>00095     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a> databuf;
<a name="l00096"></a>00096     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> pc_name;
<a name="l00097"></a>00097     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> pc_tag;
<a name="l00098"></a>00098   };
<a name="l00099"></a>00099   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;celPersistentDataEntry*&gt;</a> data_list;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101  <span class="keyword">public</span>:
<a name="l00102"></a>00102   <a class="code" href="classcelStandardPersistentDataList.html" title="Standard implementation of iCelPersistentDataList.">celStandardPersistentDataList</a> ();
<a name="l00103"></a>00103   <span class="keyword">virtual</span> ~<a class="code" href="classcelStandardPersistentDataList.html" title="Standard implementation of iCelPersistentDataList.">celStandardPersistentDataList</a> ();
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetCount ()<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">  </span>{ <span class="keywordflow">return</span> data_list.GetSize (); }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPersistentData (<span class="keywordtype">size_t</span> idx, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a>&amp; databuf, 
<a name="l00109"></a>00109         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_name, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_tag) <span class="keyword">const</span>;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> AddPersistentData (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a>&amp; databuf, 
<a name="l00112"></a>00112         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_name, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_tag);
<a name="l00113"></a>00113 };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="preprocessor">#endif // __CEL_CELTOOL_PERSISTHELPER__</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
